
#include "/settings.glsl"



#if POTATO_SHADOWS != 1

	varying vec2 lmcoord;
	varying vec2 texcoord;
	varying vec4 glcolor;
	#if UNDERWATER_CAUSTICS > 0
		uniform mat4 shadowModelViewInverse;
		uniform vec3 cameraPosition;
		varying vec3 world_pos;
	#endif
	varying float material;
#endif


attribute vec4 mc_Entity;



#include "/distort.glsl"


void main() {
#if POTATO_SHADOWS != 1
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	glcolor = gl_Color;
	
	#if UNDERWATER_CAUSTICS > 0
		//vec4 viewPos = vec4((gl_ModelViewMatrix * gl_Vertex).xyz,1.);
		//vec4 playerPos = gbufferModelViewInverse * viewPos;
		world_pos=((shadowModelViewInverse * (vec4((gl_ModelViewMatrix * gl_Vertex).xyz,1.)))).xyz+cameraPosition;
	#endif
	
	material=mc_Entity.x;//10020
#endif
	
	
	
	gl_Position = ftransform();
	
	gl_Position.xyz = distort(gl_Position.xyz);
	
	

	#if GRASS_SHADOWS == 0
		gl_Position = (mc_Entity.x == 10000.0) ? vec4(10.0) : gl_Position;
	#endif
	
	
	 
	 
	
}