vec3 calcSkyColor(vec3 pos) {
	float upDot = dot(pos, gbufferModelView[1].xyz);
	#if VANILLA_SUNSETS == 0
		float hor = (sunAngle<.25? .0 : sunAngle<.75? .5 : 1.);
		float sunset = clamp(1.-abs(sunAngle-hor)*4.,0.,1.);
		sunset*= sunAngle>= .5 ? 1. : sunset;
		bool srise = (sunAngle<.25? true : sunAngle<.75? false : true);
		sunset=  max(0., sunset*(normalize((gbufferModelViewInverse*vec4((pos.xyz), 1.)).xyz-gbufferModelViewInverse[3].xyz)).x * (srise ? 1. : -1.)
			 
		)
		;
		
		vec3 fogColor1 = mix(mix(skyColor,vec3(skyColor.b),.25+.5*Foggy),vec3(1.,.5,0.),sunset);
		return mix(skyColor, fogColor1, fogify(max(upDot, 0.0), 0.25));
	#else
		return mix(skyColor, fogColor, fogify(max(upDot, 0.0), 0.25));
	#endif

	
	
}



vec3 calcSkyColor_w(vec3 pos) {
	float upDot = dot(pos, gbufferModelView[1].xyz);
	#if VANILLA_SUNSETS == 0
		float hor = (sunAngle<.25? .0 : sunAngle<.75? .5 : 1.);
		float sunset = clamp(1.-abs(sunAngle-hor)*4.,0.,1.);
		sunset*= sunAngle>= .5 ? 1. : sunset;
		bool srise = (sunAngle<.25? true : sunAngle<.75? false : true);
		sunset=  max(0., sunset*
			//(gbufferModelViewInverse* vec4(pos,1.)).x
			pos.x
		* (srise ? 1. : -1.)
		)
		;
		
		/*
		//sunsest effect on sky
		vec3 sundir = normalize(vec4(gbufferModelViewInverse * vec4(shadowLightPosition.xyz,1.)).xyz);
		float sunset_factor = pow(1.-sundir.y,5.);
		
		#include "/stuff/suncolor.glsl"
		float pre_dot = dot(sundir,pos);
		float sun_dot = pow((pre_dot+1.)*.5,3.);
		vec3 sky_color=mix(skyColor,skyColor*sun_color, sunset_factor*(1.-sun_dot));
		sky_color+=3.*pow(sunset_factor,3.)*sun_color*sun_dot;
		
		
		vec3 fogColor1 = mix(fogColor,fogColor*sun_color, sunset_factor*(1.-sun_dot));
		fogColor1+=3.*pow(sunset_factor,3.)*sun_color*sun_dot;
		*/
		
		
		vec3 fogColor1 = mix(mix(skyColor,vec3(skyColor.b),.25+.5*Foggy),vec3(1.,.5,0.),sunset);
		
		
		
		return mix(skyColor, fogColor1, fogify(max(upDot, 0.0), 0.25));
	#else
		return mix(skyColor, fogColor, fogify(max(upDot, 0.0), 0.25));
	#endif

	
	
}


